ALLPASS    MACRO  OUT,IN,RATE,nnn
; Written by Keith Lent, University of Texas, 1988
;   A nnn SAMPLE DELAY ALLPASS FILTER
;   RATE - THE DECAY RATE COEFICIENT
;       y(n) = -RATE*x(n) + x(n-nnn) + RATE*y(n-nnn)
        ORG     YH:
_BUFF   DSM     nnn
        ORG     X:
_PTR    DC      _BUFF
        ORG     PH:,YH:
        MOVE    X:(_PTR),R4
        MOVE    #(nnn-1),M4
        MOVE    Y:(IN),X0
        MOVE    Y:(R4)+,A
        MOVE    Y:(RATE),Y1
        MACR    -X0,Y1,A        X0,B
        MOVE    A,Y:(OUT)       A,X1
        MACR    Y1,X1,B         R4,X:(_PTR)
        MOVE    B,Y:-(R4)
        ENDM
